﻿SLASH_LH1 = "/LootHistory";
SLASH_LH2 = "/lohi";
local LootHistoryVersionNumber = "2.8";
local LootHistoryVersion = "LootHistory v"..LootHistoryVersionNumber;
local LootHistoryVersionShort = "(v"..LootHistoryVersionNumber..")";
local LootHistoryRealm = GetRealmName();
local LootHistorySChildFrameTable = {};
local LootHistorySortedNames = {};
local inIni = false;
local lastIni = nil;
local editName =  "";
local editItem = 0;
local editMode = 1;
local LootHistoryMaxWidth= (GetScreenWidth() - 50);
local LootHistoryMaxHeight = (GetScreenHeight() - 50);

--begin localization
local L = {};
L["yes"]="Yes";
L["no"]="No";
L["reset"]="Reset Data?";	
L["clear"]="Reset";
L["report"]="Report";
L["Log-Options:"]="Log-Options:";
L["poor"]="Poor Items";
L["common"]="Common Items";
L["uncommon"]="Uncommon Items";
L["rare"]="Rare Items";
L["epic"]="Epic Items";
L["legendary"]="Legendary Items";
L["artifact"]="Artifact Items";
L["heirloom"]="Heirloom"
L["solo"]="Solo";
L["party"]="Party";
L["raid"]="Raid";
L["Report"]="LootHistory-Report";
L["Report:"] = "Report to:";
L["ChatFrame1"]="ChatFrame1";
L["/say"]="/say";
L["/yell"]="/yell";
L["/party"]="/party";
L["/raid"]="/raid";
L["/guild"]="/guild";
L["/whisper:"]="/whisper:";
L["General-Options:"]="General-Options:";
L["lockFrames"]="Lock Frames";
L["enableMinimapButton"]="Enable Minimap-Button";
L["lockMinimapButton"]="Lock Minimap-Button";
L["LDBClick"]="Click to open "..LootHistoryVersion;
L["Help"] = "O = Show Options|n? = Show Help|nX = Close Frame|n|n- Mouseover a row to highlight|n- Click a row to show Item-Tooltip|n- Shift-Click to copy the ItemLink into the Chatframe-EditBox|n- Alt-Left-Click to to edit the owner of selected Item(s)|n- Alt-Right-Click to to edit the owner of one of the selected Items|n|nReport = Report current LootHistory|nReset = Reset the current LootHistory";
L["loot"]="loot: "; --AddOn needs correct localization to work!!!
L["you"]="You"; --AddOn needs correct localization to work!!!
if (GetLocale() == "enUS") then
elseif (GetLocale() == "deDE") then
	L["yes"]="Ja";
	L["no"]="Nein";
	L["reset"]="Daten löschen?";	
	L["clear"]="Löschen";
	L["report"]="Berichten";
	L["Log-Options:"]="Log-Optionen:";
	L["poor"]="Schlechte Gegenstände";
	L["common"]="Gewöhnliche Gegenstände";
	L["uncommon"]="Gute Gegenstände";
	L["rare"]="Rare Gegenstände";
	L["epic"]="Epische Gegenstände";
	L["legendary"]="Legendäre Gegenstände";
	L["artifact"]="Artefakte";
	L["heirloom"]="Erbstücke"
	L["solo"]="Solo";
	L["party"]="Gruppe";
	L["raid"]="Schlachtzug";
	L["Report"]="LootHistory-Bericht";
	L["Report:"] = "Bericht an:";
	L["ChatFrame1"]="ChatFrame1";
	L["/say"]="/sagen";
	L["/yell"]="/schreien";
	L["/party"]="/gruppe";
	L["/raid"]="/schlachtzug";
	L["/guild"]="/gilde";
	L["/whisper:"]="/flüstern:";
	L["General-Options:"]="Allgemeine Optionen:";
	L["lockFrames"]="Fenster sperren";
	L["enableMinimapButton"]="Minimap anzeigen";
	L["lockMinimapButton"]="Minimap sperren";
	L["LDBClick"] = "Klicken, um "..LootHistoryVersion.." zu öffnen";
	L["Help"] = "O = Optionen|n? = Hilfe|nX = Fenster schließen|n|n- Mouseover zum hervorheben der Zeile|n- Zeile anklicken um den Item-Tooltip anzuzeigen|n- Shift-Klick um den ItemLink in die Chatframe-EditBox einzufügen|n- Alt-Links-Klick um den Besitzer der ausgewählten Items zu ändern|n- Alt-Rechts-Klick um den Besitzer eines der ausgewählten Items zu ändern|n|nBerichten = LootHistory-Bericht erstellen|nReset = LootHistory zurücksetzen";
	L["loot"]="Beute: ";
	L["you"]="Ihr";
elseif (GetLocale() == "zhCN") then
    L["loot"]="获得了物品: "; 
    L["you"]="你";
else
	--[[ 
	feel free to create the following localizations (you can contact me via curse.com):
	"frFR": French
	"koKR": Korean
	"zhCN": Chinese (simplified)
	"zhTW": Chinese (traditional)
	"ruRU": Russian (UI AddOn)
	"esES": Spanish (Spain)
	"esMX": Spanish (Mexico)
	]]--
	ChatFrame1:AddMessage("|cffff0000"..LootHistoryVersion..": Your WoW-Version isn't compatible. This is caused by localization issues.|r");
end
--end localization

local function LootHistorytobool(arg1)
	if arg1 == 1 or arg1 == true then	
		return true;
	else
		return false;
	end
end

local function LootHistoryToggle()
	if LootHistoryFrame:IsShown() then
		LootHistoryFrame:Hide();
		LootHistoryOptionsFrame:Hide();
	elseif not LootHistoryFrame:IsShown() then
		LootHistoryFrame:Show();
	end
end

local function AddToChatFrameEditBox(itemLink)
	local x = { SELECTED_DOCK_FRAME:GetChildren() };
	local editbox = x[4];
	if editbox then
		if editbox:HasFocus() then
			editbox:SetText(editbox:GetText()..itemLink);
		else
			editbox:SetFocus(true);
			editbox:SetText(itemLink);
		end
	end
end

local function LootHistory_tinsert(userName, text)		
	local s = string.find(text, "%|");
	local e = string.find(text, "%|h%|r");
	local itemName, itemLink, _, _, _, _, _, _, _, _, _ = GetItemInfo(string.sub(text, s, e));
	if itemName then
		local itemCount = 1;
		if ((e + 5) <= #text) then
			itemCount = tonumber(string.sub(text, e + 5, #text));
		end
		if LootHistory[userName] == nil then
			LootHistory[userName]={};
			tinsert(LootHistory[userName], text);
			return true;
		else
			local i = 1;
			local inserted = false;
			local n = #LootHistory[userName];
			while i <= n do
				local v = LootHistory[userName][i];
				local a, _ = strfind(v, "%[");
				local b, _ = strfind(v, "%]");
				local itemName2 = strsub(v, a + 1, b - 1);
				if itemName == itemName2 then
					if ((b + 6) <= #v) then
						itemCount = itemCount + tonumber(string.sub(v, b + 6, #v));
					else
						itemCount = itemCount + 1;
					end
					text = itemLink.."x"..itemCount;											
					LootHistory[userName][i] = text;
					inserted = true;
					i = n;				
				end					
				i = i + 1;
			end
			if not inserted then
				local i = 1;				
				local n = #LootHistory[userName] + 1;
				while i <= n do
					if i == n then
						tinsert(LootHistory[userName], text);
					else
						local v = LootHistory[userName][i];					
						local a, _ = strfind(v, "%[");
						local b, _ = strfind(v, "%]");
						local itemName2 = strsub(v, a + 1, b - 1);
						if itemName < itemName2 then
							tinsert(LootHistory[userName], i, text);
							i = n;						
						end					
					end
					i = i + 1;
				end
			end
		end
	end
end

local function LootHistorySort(db)
	local database = {};
	for name, text in pairs(db) do
		local i = 1
		local n = #database + 1;
		while i <= n do			
			if i == n then
				tinsert(database, name);
			elseif name <= database[i] then
				tinsert(database, i, name);					
				i = n;			
			end
			i = i + 1;
		end
	end
	return database;
end

local function LootHistoryReport(message)
	if LootHistoryReportTo["ChatFrame1"] then
		print(message);
	end
	if LootHistoryReportTo["Say"] then
		SendChatMessage(message, "SAY");
	end
	if LootHistoryReportTo["Yell"] then
		SendChatMessage(message, "YELL");
	end
	if LootHistoryReportTo["Party"] then
		if GetNumPartyMembers() > 0 then
			SendChatMessage(message, "PARTY");
		elseif GetNumRaidMembers() > 0 then
			SendChatMessage(message, "PARTY");
		end
	end
	if ((LootHistoryReportTo["Raid"]) and (GetNumRaidMembers() > 0)) then
		SendChatMessage(message, "RAID");
	end
	if LootHistoryReportTo["Guild"] then
		local guild = GetGuildInfo("player");		
		if (not(guild == nil)) then
			SendChatMessage(message, "GUILD");
		end
	end
	if LootHistoryReportTo["Whisper"] then
		local h = LootHistoryReportFrameWhisperBox:GetText();
		if (not (h == nil)) then
			SendChatMessage(message, "WHISPER", nil, h);
		end
	end
end

local function LootHistoryReportData()
	if (LootHistory and LootHistorySortedNames and LootHistorySChildFrameTable[1]:IsShown()) then		
		LootHistoryReport(L["Report"].." "..LootHistoryVersionShort..":");
		for _, userName in ipairs(LootHistorySortedNames) do
			local itemList = LootHistory[userName];
			for _, itemLink in ipairs(itemList) do
				LootHistoryReport(userName..": "..itemLink);
			end
		end
	end
end

local function LootHistoryCreateSChildFrame(j)
	local n = #LootHistorySChildFrameTable;
	if n == 0 then
		local LootHistorySChildFrame = CreateFrame("FRAME", nil, LootHistoryFrameSChild);
		LootHistorySChildFrame:SetFrameStrata("TOOLTIP"); 
		LootHistorySChildFrame:SetWidth(210);
		LootHistorySChildFrame:SetHeight(15);		
		LootHistorySChildFrame:SetPoint("TOPLEFT");
		LootHistorySChildFrame:Hide();
			
		local LootHistorySChildFrameText = LootHistorySChildFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
		LootHistorySChildFrameText:SetTextColor(1.0, 1.0, 1.0, 0.8);		
		LootHistorySChildFrameText:SetPoint("LEFT");	
		
		tinsert(LootHistorySChildFrameTable, LootHistorySChildFrame);
	else
		for i = n, j + n do	
			local LootHistorySChildFrame = CreateFrame("FRAME", nil, LootHistoryFrameSChild);
			LootHistorySChildFrame:SetFrameStrata("TOOLTIP"); 
			LootHistorySChildFrame:SetWidth(210);
			LootHistorySChildFrame:SetHeight(15);		
			LootHistorySChildFrame:SetPoint("TOPLEFT", LootHistorySChildFrameTable[i], "BOTTOMLEFT");
			LootHistorySChildFrame:Hide();
				
			local LootHistorySChildFrameText = LootHistorySChildFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
			LootHistorySChildFrameText:SetTextColor(1.0, 1.0, 1.0, 0.8);		
			LootHistorySChildFrameText:SetPoint("LEFT");	
			
			tinsert(LootHistorySChildFrameTable, LootHistorySChildFrame);
		end
	end
end

local function LootHistoryHideSChildFrame(j)
--Hides all SChildFrames, beginning at Position j
	local n = #LootHistorySChildFrameTable;
	for i = j, n do
		LootHistorySChildFrameTable[i]:Hide();
	end
end

local function LootHistoryRefreshSChildFrame()
--Refreshs the SChildFrame
	local n = #LootHistorySChildFrameTable;
	local i = 1;
	LootHistorySortedNames = LootHistorySort(LootHistory);
	for _, userName in ipairs(LootHistorySortedNames) do
		for j, itemLink in ipairs(LootHistory[userName]) do
			if i > n then
				LootHistoryCreateSChildFrame(1);
			end			
			LootHistorySChildFrameTable[i]:GetRegions():SetText(userName ..": "..itemLink);			
			LootHistorySChildFrameTable[i]:SetScript("OnMouseUp", function(self, button)
												if IsShiftKeyDown() then
												--copy into chatframe
													AddToChatFrameEditBox(itemLink);
												elseif IsControlKeyDown() then
												--preview item
													DressUpItemLink(itemLink);
												elseif IsAltKeyDown() then
												--edit
													editName = userName;
													editItem = j;
													editMode = 1;
													LootHistoryEditFrameLoot:SetText(": "..itemLink);													
													if button == "RightButton" then													
														editMode = 2;
														local e = string.find(itemLink, "%|h%|r");
														LootHistoryEditFrameLoot:SetText(": "..string.sub(itemLink, 1, e - 1));
													end																									
													LootHistoryEditFrameBox:SetText(userName);
													LootHistoryEditFrame:Show();
													LootHistoryEditFrameBox:SetFocus(true);
												else
													LootHistoryItemTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" );
													LootHistoryItemTooltip:SetFrameLevel(LootHistoryFrameSChild:GetFrameLevel() + 1);
													LootHistoryItemTooltip:SetPoint("BOTTOM", self, "TOP", 0, 0);
													LootHistoryItemTooltip:SetHyperlink(itemLink);													
													LootHistoryItemTooltip:Show();
												end
											end);
			LootHistorySChildFrameTable[i]:SetScript("OnEnter", function(self)
												self:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background"});
												self:SetBackdropColor(0.8,0.8,0.8,0.9);
											end);
			LootHistorySChildFrameTable[i]:SetScript("OnLeave", function(self)
												self:SetBackdrop(nil);												
											end);
			LootHistorySChildFrameTable[i]:Show();
			i = i + 1;
		end		
	end
	LootHistoryHideSChildFrame(i);
	if (LootHistorySChildFrameTable[1] and LootHistorySChildFrameTable[1]:IsShown()) then
		LootHistoryFrameShowButton:Enable();
		LootHistoryFrameClearButton:Enable();
	else
		LootHistoryFrameShowButton:Disable();
		LootHistoryFrameClearButton:Disable();
	end
end

local function ClearLootHistory()	
	wipe(LootHistory);
	wipe(LootHistorySortedNames);
	LootHistoryHideSChildFrame(1);
	LootHistoryFrameShowButton:Disable();
	LootHistoryFrameClearButton:Disable();
end

local function LootHistoryAdd(arg1)	
	local inRaid = false;
	if GetNumRaidMembers() > 0 then
		inRaid = true;
	end
	local inParty = false;
	if GetNumPartyMembers() > 0 then
		inParty = true;
	end
	if (LootHistoryLog["Raid"] and inRaid) or 
	   (LootHistoryLog["Party"] and inParty and not inRaid) or
	   (LootHistoryLog["Solo"] and not inParty and not inRaid)
	then
		local s = string.find(arg1, "%|");
		local e = string.find(arg1, "%|h%|r");
		local _, _, itemRarity, _, _, itemType, _, _, _, _, _ = GetItemInfo(string.sub(arg1, s, e - 1));
		local userName = string.sub(arg1, 0, (string.find(arg1, " ")-1));	
		if userName == L["you"] then
			userName = UnitName("PLAYER");		
		end
		if (not(itemType == "Money")) and ((LootHistoryItemRarity[0] and itemRarity == 0) or
										   (LootHistoryItemRarity[1] and itemRarity == 1) or
										   (LootHistoryItemRarity[2] and itemRarity == 2) or
										   (LootHistoryItemRarity[3] and itemRarity == 3) or
										   (LootHistoryItemRarity[4] and itemRarity == 4) or
										   (LootHistoryItemRarity[5] and itemRarity == 5) or
										   (LootHistoryItemRarity[6] and itemRarity == 6)
										) then
			LootHistory_tinsert(userName, string.sub(arg1, s, #arg1 - 1));
			LootHistoryRefreshSChildFrame();
		end
	end
end

SlashCmdList["LH"] = function(args)
	if args == "toggle" then
		LootHistoryToggle();
	end	
end

local function LootHistoryOnEvent(event, arg1)	
	if (event == "ADDON_LOADED" and arg1 == "LootHistory") then
		if LootHistory == nil then
			LootHistory = {};
		end
		if LootHistoryItemRarity == nil then
			LootHistoryItemRarity = {};
			LootHistoryItemRarity[0]=false; --poor (grey)
			LootHistoryItemRarity[1]=false; --common (white)
			LootHistoryItemRarity[2]=true; --uncommon (green)
			LootHistoryItemRarity[3]=true; --rare (blue)
			LootHistoryItemRarity[4]=true; --epic (purple)
			LootHistoryItemRarity[5]=true; --legendary (orange)
			LootHistoryItemRarity[6]=false; --artifact
			--LootHistoryItemRarity[7]=false; --heirloom
		end
		if LootHistoryReportTo == nil then
			LootHistoryReportTo = {};
			LootHistoryReportTo["ChatFrame1"]=true;
			LootHistoryReportTo["Say"]=false;
			LootHistoryReportTo["Yell"]=false;
			LootHistoryReportTo["Party"]=false;
			LootHistoryReportTo["Raid"]=false;
			LootHistoryReportTo["Guild"]=false;
			LootHistoryReportTo["Whisper"]=false;
		end
		if LootHistoryLog == nil then 
			LootHistoryLog = {};
			LootHistoryLog["Solo"]=false;
			LootHistoryLog["Party"]=true;
			LootHistoryLog["Raid"]=true;
		end
		if LootHistory_LockFrames == nil then
			LootHistory_LockFrames = false;
		end
		if LootHistory_LockMinimapButton == nil then
			LootHistory_LockMinimapButton = false;
		end
		if LootHistory_Frame == nil then
			LootHistory_Frame = {};
			LootHistory_Frame["width"] = 250;
			LootHistory_Frame["height"] = 200;
			LootHistory_Frame["point"] = "CENTER";
			LootHistory_Frame["x"] = 0;
			LootHistory_Frame["y"] = 0;
		end
		if LootHistory_MinimapButtonPosition == nil then
			LootHistory_MinimapButtonPosition = {};
			LootHistory_MinimapButtonPosition["point"] = "TOP";
			LootHistory_MinimapButtonPosition["x"] = 0;
			LootHistory_MinimapButtonPosition["y"] = 0;
		end
		if LootHistory_EnableMinimapButton == nil then
			LootHistory_EnableMinimapButton = true;
		end
		if LootHistory_LockShowLootFrame == nil then
			LootHistory_LockShowLootFrame = false;
		end	
		LootHistoryOptionsCheckButtonLog0:SetChecked(LootHistoryItemRarity[0]);
		LootHistoryOptionsCheckButtonLog1:SetChecked(LootHistoryItemRarity[1]);
		LootHistoryOptionsCheckButtonLog2:SetChecked(LootHistoryItemRarity[2]);
		LootHistoryOptionsCheckButtonLog3:SetChecked(LootHistoryItemRarity[3]);
		LootHistoryOptionsCheckButtonLog4:SetChecked(LootHistoryItemRarity[4]);
		LootHistoryOptionsCheckButtonLog5:SetChecked(LootHistoryItemRarity[5]);
		LootHistoryOptionsCheckButtonLog6:SetChecked(LootHistoryItemRarity[6]);
		
		LootHistoryOptionsCheckButtonLogSolo:SetChecked(LootHistoryLog["Solo"]);
		LootHistoryOptionsCheckButtonLogParty:SetChecked(LootHistoryLog["Party"]);
		LootHistoryOptionsCheckButtonLogRaid:SetChecked(LootHistoryLog["Raid"]);
		
		LootHistoryReportFrameCheckButtonChatFrame:SetChecked(LootHistoryReportTo["ChatFrame1"]);
		LootHistoryReportFrameCheckButtonSay:SetChecked(LootHistoryReportTo["Say"]);
		LootHistoryReportFrameCheckButtonYell:SetChecked(LootHistoryReportTo["Yell"]);
		LootHistoryReportFrameCheckButtonParty:SetChecked(LootHistoryReportTo["Party"]);
		LootHistoryReportFrameCheckButtonRaid:SetChecked(LootHistoryReportTo["Raid"]);
		LootHistoryReportFrameCheckButtonGuild:SetChecked(LootHistoryReportTo["Guild"]);
		LootHistoryReportFrameCheckButtonWhisper:SetChecked(LootHistoryReportTo["Whisper"]);
		
		LootHistoryOptionsCheckButtonLockFrames:SetChecked(LootHistory_LockFrames);
		LootHistoryOptionsCheckButtonEnableMinimapButton:SetChecked(LootHistory_EnableMinimapButton);
		LootHistoryOptionsCheckButtonLockMinimapButton:SetChecked(LootHistory_LockMinimapButton);		
		
		LootHistoryFrame:SetWidth(LootHistory_Frame["width"]);
		LootHistoryFrame:SetHeight(LootHistory_Frame["height"]);
		LootHistoryFrame:SetPoint(LootHistory_Frame["point"], LootHistory_Frame["x"], LootHistory_Frame["y"]);
		
		if not LootHistory_LockFrames then		
			LootHistoryTopFrame:RegisterForDrag("LeftButton");			
		end
				
		LootHistoryMinimapButton:SetPoint(LootHistory_MinimapButtonPosition["point"], Minimap, LootHistory_MinimapButtonPosition["x"], LootHistory_MinimapButtonPosition["y"]);
		if LootHistory_EnableMinimapButton then
			LootHistoryMinimapButton:Show();
		else
			LootHistoryMinimapButton:Hide();
		end	
		if not LootHistory_LockMinimapButton then		
			LootHistoryMinimapButton:RegisterForDrag("LeftButton");			
		end
		LootHistoryRefreshSChildFrame();
	end
	if event == "CHAT_MSG_LOOT" then
		if (arg1 and (strfind(arg1, L["loot"]))) then
			LootHistoryAdd(arg1);
		end
	end
	if event == "PLAYER_ENTERING_WORLD" then
		local inInstance, _ = IsInInstance();
		inInstance = LootHistorytobool(inInstance);
		local iniName = GetInstanceInfo();		
		if ((inIni == false and inInstance) and not(lastIni == iniName)) then
			inIni = true;
			lastIni = iniName;
			if ((UnitInRaid("Player") and LootHistoryLog["Raid"]) or (UnitInParty("Player") and not UnitInRaid("Player") and LootHistoryLog["Party"]) or (LootHistoryLog["Solo"] and not UnitInRaid("Player") and not UnitInParty("Player"))) then
				LootHistoryResetFrame:Show();
			end
		elseif (inIni and inInstance == false) then
			inIni = false;			
		end
	end
end

--LDB
local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
local dataobj = ldb:GetDataObjectByName("LootHistory") or ldb:NewDataObject("LootHistory", {
	type = "data source", icon = [[Interface\AddOns\LootHistory\LootHistoryLDBIcon]], text = "LootHistory",
	OnClick = function() LootHistoryToggle() end,
	OnTooltipShow = function(tip)
		tip:AddLine(L["LDBClick"]);
	end,
})
--end LDB

-- begin UI
local LootHistoryMinimapButton = CreateFrame("BUTTON", "LootHistoryMinimapButton", Minimap);
LootHistoryMinimapButton:SetWidth(31);
LootHistoryMinimapButton:SetHeight(31);
LootHistoryMinimapButton:SetFrameStrata("LOW");
LootHistoryMinimapButton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
LootHistoryMinimapButton:SetPoint("RIGHT", Minimap, "LEFT");
LootHistoryMinimapButtonIcon = LootHistoryMinimapButton:CreateTexture(nil, "BACKGROUND");
LootHistoryMinimapButtonIcon:SetTexture("Interface\\AddOns\\LootHistory\\LootHistoryIcon");
LootHistoryMinimapButtonIcon:SetPoint("TOPLEFT", 6, -6);
LootHistoryMinimapButtonIcon:SetPoint("BOTTOMRIGHT", -6, 6);
LootHistoryMinimapButtonOverlay = LootHistoryMinimapButton:CreateTexture(nil, "OVERLAY");
LootHistoryMinimapButtonOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
LootHistoryMinimapButtonOverlay:SetWidth(53);
LootHistoryMinimapButtonOverlay:SetHeight(53);
LootHistoryMinimapButtonOverlay:SetPoint("TOPLEFT");
LootHistoryMinimapButton:SetMovable(true);
LootHistoryMinimapButton:EnableMouse(true);
LootHistoryMinimapButton:SetScript("OnDragStart", function() LootHistoryMinimapButton:StartMoving() end);
LootHistoryMinimapButton:SetScript("OnDragStop", function()
													LootHistoryMinimapButton:StopMovingOrSizing();
													local point, relativeTo, relativePoint, x, y = LootHistoryMinimapButton:GetPoint();
													LootHistory_MinimapButtonPosition["point"] = point;													
													LootHistory_MinimapButtonPosition["x"] = x;
													LootHistory_MinimapButtonPosition["y"] = y;
												 end);
LootHistoryMinimapButton:SetScript("OnClick", function() LootHistoryToggle(); end);										
LootHistoryMinimapButton:Hide();

local LootHistoryResetFrame = CreateFrame("FRAME", "LootHistoryResetFrame", UIParent);
LootHistoryResetFrame:SetWidth(160);
LootHistoryResetFrame:SetHeight(70);
LootHistoryResetFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryResetFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryResetFrame:EnableMouse(true);
LootHistoryResetFrame:RegisterForDrag("LeftButton");
LootHistoryResetFrame:SetMovable(true);
LootHistoryResetFrame:SetUserPlaced(true);
LootHistoryResetFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LootHistoryResetFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LootHistoryResetFrame:SetPoint("Center", 0, 100);
LootHistoryResetFrame:Hide();
tinsert(UISpecialFrames, LootHistoryResetFrame:GetName());

local LootHistoryResetTopFrame = CreateFrame("FRAME", nil, LootHistoryResetFrame);
LootHistoryResetTopFrame:SetWidth(120);
LootHistoryResetTopFrame:SetHeight(25);
LootHistoryResetTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryResetTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryResetTopFrame:SetPoint("TOP", 0, 10);
LootHistoryResetTopFrame:Show();

local LootHistoryResetFrameText = LootHistoryResetTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryResetFrameText:SetTextColor(1, 0, 0, 1.0);
LootHistoryResetFrameText:SetText(LootHistoryVersion);
LootHistoryResetFrameText:SetPoint("CENTER");

local LootHistoryResetFrameText2 = LootHistoryResetFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryResetFrameText2:SetTextColor(1, 1, 1, 1.0);
LootHistoryResetFrameText2:SetText(L["reset"]);
LootHistoryResetFrameText2:SetPoint("CENTER", 0, 5);

local LootHistoryResetFrameClose = CreateFrame("BUTTON", nil, LootHistoryResetFrame, "UIPanelButtonTemplate");
LootHistoryResetFrameClose:SetWidth(15);
LootHistoryResetFrameClose:SetHeight(15);
LootHistoryResetFrameClose:SetText("X");
LootHistoryResetFrameClose:SetPoint("TOPRIGHT", -5, -5);
LootHistoryResetFrameClose:SetScript("OnClick", function()
											LootHistoryResetFrame:Hide();											
										   end);
LootHistoryResetFrameClose:SetAlpha(1);
LootHistoryResetFrameClose:Show();

local LootHistoryResetFrameNoButton = CreateFrame("BUTTON", nil, LootHistoryResetFrame, "UIPanelButtonTemplate");
LootHistoryResetFrameNoButton:SetWidth(70);
LootHistoryResetFrameNoButton:SetHeight(20);
LootHistoryResetFrameNoButton:SetText(L["no"]);
LootHistoryResetFrameNoButton:SetPoint("BOTTOMRIGHT", -7, 5);
LootHistoryResetFrameNoButton:SetScript("OnClick", function()
											LootHistoryResetFrame:Hide();
										   end);
LootHistoryResetFrameNoButton:SetAlpha(1);
LootHistoryResetFrameNoButton:Show();

local LootHistoryResetFrameYesButton = CreateFrame("BUTTON", nil, LootHistoryResetFrame, "UIPanelButtonTemplate");
LootHistoryResetFrameYesButton:SetWidth(70);
LootHistoryResetFrameYesButton:SetHeight(20);
LootHistoryResetFrameYesButton:SetText(L["yes"]);
LootHistoryResetFrameYesButton:SetPoint("BOTTOMLEFT", 7, 5);
LootHistoryResetFrameYesButton:SetScript("OnClick", function()
														ClearLootHistory();
														LootHistoryResetFrame:Hide();
												end);
LootHistoryResetFrameYesButton:SetAlpha(1);
LootHistoryResetFrameYesButton:Show();

local LootHistoryFrame, events = CreateFrame("FRAME", "LootHistoryFrame", UIParent);
LootHistoryFrame:SetFrameStrata("TOOLTIP"); 
LootHistoryFrame:RegisterEvent("ADDON_LOADED");
LootHistoryFrame:RegisterEvent("CHAT_MSG_LOOT");
LootHistoryFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
LootHistoryFrame:SetScript("OnEvent", function(self, event, arg1, ...)
										LootHistoryOnEvent(event, arg1);
										end);
LootHistoryFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryFrame:EnableMouse(true);
LootHistoryFrame:SetMovable(true);
LootHistoryFrame:SetUserPlaced(true);
LootHistoryFrame:SetScript("OnSizeChanged", function()
												LootHistoryFrameSChild:SetWidth(LootHistoryFrame:GetWidth() - 30);
												LootHistorySFrame:SetWidth(LootHistoryFrameSChild:GetWidth() - 18);
												LootHistorySFrame:SetHeight(LootHistoryFrame:GetHeight() - 65);
												LootHistoryOptionsFrame:SetWidth(LootHistoryFrame:GetWidth());
												LootHistoryHelpFrame:SetWidth(LootHistoryFrame:GetWidth());
											end);
LootHistoryFrame:SetResizable(true);
LootHistoryFrame:SetMaxResize(LootHistoryMaxWidth, LootHistoryMaxHeight);
LootHistoryFrame:SetMinResize(250, 200);										  
LootHistoryFrame:Hide();
tinsert(UISpecialFrames, LootHistoryFrame:GetName());

local LootHistoryTopFrame = CreateFrame("FRAME", "LootHistoryTopFrame", LootHistoryFrame);
LootHistoryTopFrame:SetWidth(120);
LootHistoryTopFrame:SetHeight(25);
LootHistoryTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryTopFrame:SetPoint("TOP", 0, 10);
LootHistoryTopFrame:EnableMouse(true);
LootHistoryTopFrame:SetScript("OnDragStart", function()
												LootHistoryFrame:StartMoving(); 
												LootHistoryTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
											end);
LootHistoryTopFrame:SetScript("OnDragStop", function()
											LootHistoryFrame:StopMovingOrSizing();
											local point, relativeTo, relativePoint, x, y = LootHistoryFrame:GetPoint();
											LootHistory_Frame["point"] = point;													
											LootHistory_Frame["x"] = x;
											LootHistory_Frame["y"] = y;
											LootHistory_Frame["width"] = LootHistoryFrame:GetWidth();
											LootHistory_Frame["height"] = LootHistoryFrame:GetHeight();
											if (not MouseIsOver(LootHistoryTopFrame)) then
												LootHistoryTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
											end
										  end);
LootHistoryTopFrame:SetScript("OnEnter", function()
													LootHistoryTopFrame:SetBackdropColor(1.0,1.0,1.0,0.9);
												end);
LootHistoryTopFrame:SetScript("OnLeave", function()
													if (not IsMouseButtonDown("LeftButton")) then
														LootHistoryTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
													end
												end);										  
LootHistoryTopFrame:Show();

local LootHistoryFrameText = LootHistoryTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryFrameText:SetTextColor(1, 0, 0, 1.0);
LootHistoryFrameText:SetText(LootHistoryVersion);
LootHistoryFrameText:SetPoint("CENTER");

local LootHistoryFrameOptions = CreateFrame("BUTTON", nil, LootHistoryFrame, "UIPanelButtonTemplate");
LootHistoryFrameOptions:SetWidth(15);
LootHistoryFrameOptions:SetHeight(15);
LootHistoryFrameOptions:SetText("O");
LootHistoryFrameOptions:SetPoint("TOPLEFT", 5, -5);
LootHistoryFrameOptions:SetScript("OnClick", function()
												if LootHistoryOptionsFrame:IsShown() then
													LootHistoryOptionsFrame:Hide();													
												elseif not LootHistoryOptionsFrame:IsShown() then
													LootHistoryOptionsFrame:Show();
												end											
											 end);
LootHistoryFrameOptions:SetAlpha(1);
LootHistoryFrameOptions:Show();

local LootHistoryFrameClose = CreateFrame("BUTTON", nil, LootHistoryFrame, "UIPanelButtonTemplate");
LootHistoryFrameClose:SetWidth(15);
LootHistoryFrameClose:SetHeight(15);
LootHistoryFrameClose:SetText("X");
LootHistoryFrameClose:SetPoint("TOPRIGHT", -5, -5);
LootHistoryFrameClose:SetScript("OnClick", function()
											LootHistoryFrame:Hide();
											LootHistoryOptionsFrame:Hide();
											LootHistoryHelpFrame:Hide();
										   end);
LootHistoryFrameClose:SetAlpha(1);
LootHistoryFrameClose:Show();

local LootHistoryFrameHelp = CreateFrame("BUTTON", nil, LootHistoryFrame, "UIPanelButtonTemplate");
LootHistoryFrameHelp:SetWidth(15);
LootHistoryFrameHelp:SetHeight(15);
LootHistoryFrameHelp:SetText("?");
LootHistoryFrameHelp:SetPoint("RIGHT", LootHistoryFrameClose, "LEFT", -5, 0);
LootHistoryFrameHelp:SetScript("OnClick", function()
											if LootHistoryHelpFrame:IsShown() then
												LootHistoryHelpFrame:Hide();
											else
												LootHistoryHelpFrame:Show();
											end
										   end);
LootHistoryFrameHelp:SetAlpha(1);
LootHistoryFrameHelp:Show();

local LootHistorySFrame = CreateFrame("SCROLLFRAME", "LootHistorySFrame", LootHistoryFrame, "UIPanelScrollFrameTemplate");
local LootHistoryFrameSChild = CreateFrame("FRAME", "LootHistoryFrameSChild", LootHistorySFrame);
LootHistorySFrame:SetScrollChild(LootHistoryFrameSChild);
LootHistorySFrame:SetPoint("TOPLEFT", LootHistoryFrame, "TOPLEFT", 10, -25);
LootHistorySFrame:SetWidth(LootHistoryFrame:GetWidth() - 48);
LootHistorySFrame:SetHeight(LootHistoryFrame:GetHeight() - 65);
LootHistorySFrame:SetHorizontalScroll(0);
LootHistorySFrame:SetVerticalScroll(20);
LootHistorySFrame:EnableMouse(true);
LootHistorySFrame:Show();
LootHistoryFrameSChild:SetPoint("TOPLEFT");
LootHistoryFrameSChild:SetWidth(LootHistoryFrame:GetWidth() - 30);
LootHistoryFrameSChild:SetHeight(50);
LootHistoryFrameSChild:Show();

local LootHistoryFrameClearButton = CreateFrame("BUTTON", "LootHistoryFrameClearButton", LootHistoryFrame, "UIPanelButtonTemplate");
LootHistoryFrameClearButton:SetWidth(105);
LootHistoryFrameClearButton:SetHeight(20);
LootHistoryFrameClearButton:SetText(L["clear"]);
LootHistoryFrameClearButton:SetPoint("BOTTOMRIGHT", -17, 10);
LootHistoryFrameClearButton:SetScript("OnClick", function() LootHistoryResetFrame:Show(); end);
LootHistoryFrameClearButton:SetAlpha(1);
LootHistoryFrameClearButton:Show();

local LootHistoryFrameShowButton = CreateFrame("BUTTON", "LootHistoryFrameShowButton", LootHistoryFrame, "UIPanelButtonTemplate");
LootHistoryFrameShowButton:SetWidth(105);
LootHistoryFrameShowButton:SetHeight(20);
LootHistoryFrameShowButton:SetText(L["report"]);
LootHistoryFrameShowButton:SetPoint("BOTTOMLEFT", 17, 10);
LootHistoryFrameShowButton:SetScript("OnClick", function()if LootHistoryReportFrame:IsShown() then
													LootHistoryReportFrame:Hide();													
												elseif not LootHistoryReportFrame:IsShown() then
													LootHistoryReportFrame:Show();
												end	
												end);
LootHistoryFrameShowButton:SetAlpha(1);
LootHistoryFrameShowButton:Show();

local LootHistoryFrameResize = CreateFrame("BUTTON", "LootHistoryFrameResize", LootHistoryFrame);
LootHistoryFrameResize:SetWidth(16);
LootHistoryFrameResize:SetHeight(16);
LootHistoryFrameResize:SetPoint("BOTTOMRIGHT", LootHistoryFrame, "BOTTOMRIGHT", -2, 2);
LootHistoryFrameResize:SetNormalTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton");
LootHistoryFrameResize:SetHighlightTexture("Interface\\AddOns\\LootHistory\\LootHistoryResizeButton");
LootHistoryFrameResize:SetScript("OnMouseDown", function()
													LootHistoryFrame:StartSizing();
												end);
LootHistoryFrameResize:SetScript("OnMouseUp", function()
												LootHistoryFrame:StopMovingOrSizing();
												LootHistoryFrameSChild:SetWidth(LootHistoryFrame:GetWidth() - 30);
												LootHistorySFrame:SetWidth(LootHistoryFrameSChild:GetWidth() - 18);
												LootHistorySFrame:SetHeight(LootHistoryFrame:GetHeight() - 65);
												local point, _, _, x, y = LootHistoryFrame:GetPoint();
												LootHistory_Frame["point"] = point;													
												LootHistory_Frame["x"] = x;
												LootHistory_Frame["y"] = y;
												LootHistory_Frame["width"] = LootHistoryFrame:GetWidth();
												LootHistory_Frame["height"] = LootHistoryFrame:GetHeight();
											end);

local LootHistoryOptionsFrame = CreateFrame("FRAME", "LootHistoryOptionsFrame", UIParent);
LootHistoryOptionsFrame:SetWidth(LootHistoryFrame:GetWidth());
LootHistoryOptionsFrame:SetHeight(265);
LootHistoryOptionsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryOptionsFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryOptionsFrame:SetPoint("TOPLEFT", LootHistoryFrame, "BOTTOMLEFT", 0, 0);
tinsert(UISpecialFrames, LootHistoryOptionsFrame:GetName());
LootHistoryOptionsFrame:Hide();

local LootHistoryOptionsText1 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsText1:SetTextColor(1.0, 0.8, 0, 0.8);
LootHistoryOptionsText1:SetWidth(175);
LootHistoryOptionsText1:SetJustifyH("LEFT");
LootHistoryOptionsText1:SetText(L["Log-Options:"]);
LootHistoryOptionsText1:SetPoint("TOPLEFT", 5, -5);

local LootHistoryOptionsLog0 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog0:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog0:SetWidth(175);
LootHistoryOptionsLog0:SetHeight(15);
LootHistoryOptionsLog0:SetJustifyH("LEFT");
LootHistoryOptionsLog0:SetText(L["poor"]);
LootHistoryOptionsLog0:SetPoint("TOP", LootHistoryOptionsText1, "BOTTOM", 25, -5);

local LootHistoryOptionsCheckButtonLog0 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog0", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog0:SetWidth(15);
LootHistoryOptionsCheckButtonLog0:SetHeight(15);
LootHistoryOptionsCheckButtonLog0:SetPoint("RIGHT", LootHistoryOptionsLog0, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog0:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog0:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog0:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog0:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog0:SetScript("OnClick", function() LootHistoryItemRarity[0] = LootHistorytobool(LootHistoryOptionsCheckButtonLog0:GetChecked()); end);
LootHistoryOptionsCheckButtonLog0:Show();

local LootHistoryOptionsLog1 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog1:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog1:SetWidth(175);
LootHistoryOptionsLog1:SetHeight(15);
LootHistoryOptionsLog1:SetJustifyH("LEFT");
LootHistoryOptionsLog1:SetText(L["common"]);
LootHistoryOptionsLog1:SetPoint("TOP", LootHistoryOptionsLog0, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog1 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog1", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog1:SetWidth(15);
LootHistoryOptionsCheckButtonLog1:SetHeight(15);
LootHistoryOptionsCheckButtonLog1:SetPoint("RIGHT", LootHistoryOptionsLog1, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog1:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog1:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog1:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog1:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog1:SetScript("OnClick", function() LootHistoryItemRarity[1] = LootHistorytobool(LootHistoryOptionsCheckButtonLog1:GetChecked()); end);
LootHistoryOptionsCheckButtonLog1:Show();

local LootHistoryOptionsLog2 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog2:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog2:SetWidth(175);
LootHistoryOptionsLog2:SetHeight(15);
LootHistoryOptionsLog2:SetJustifyH("LEFT");
LootHistoryOptionsLog2:SetText(L["uncommon"]);
LootHistoryOptionsLog2:SetPoint("TOP", LootHistoryOptionsLog1, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog2= CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog2", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog2:SetWidth(15);
LootHistoryOptionsCheckButtonLog2:SetHeight(15);
LootHistoryOptionsCheckButtonLog2:SetPoint("RIGHT", LootHistoryOptionsLog2, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog2:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog2:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog2:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog2:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog2:SetScript("OnClick", function() LootHistoryItemRarity[2] = LootHistorytobool(LootHistoryOptionsCheckButtonLog2:GetChecked()); end);
LootHistoryOptionsCheckButtonLog2:Show();

local LootHistoryOptionsLog3 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog3:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog3:SetWidth(175);
LootHistoryOptionsLog3:SetHeight(15);
LootHistoryOptionsLog3:SetJustifyH("LEFT");
LootHistoryOptionsLog3:SetText(L["rare"]);
LootHistoryOptionsLog3:SetPoint("TOP", LootHistoryOptionsLog2, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog3 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog3", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog3:SetWidth(15);
LootHistoryOptionsCheckButtonLog3:SetHeight(15);
LootHistoryOptionsCheckButtonLog3:SetPoint("RIGHT", LootHistoryOptionsLog3, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog3:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog3:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog3:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog3:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog3:SetScript("OnClick", function() LootHistoryItemRarity[3] = LootHistorytobool(LootHistoryOptionsCheckButtonLog3:GetChecked()); end);
LootHistoryOptionsCheckButtonLog3:Show();

local LootHistoryOptionsLog4 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog4:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog4:SetWidth(175);
LootHistoryOptionsLog4:SetHeight(15);
LootHistoryOptionsLog4:SetJustifyH("LEFT");
LootHistoryOptionsLog4:SetText(L["epic"]);
LootHistoryOptionsLog4:SetPoint("TOP", LootHistoryOptionsLog3, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog4 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog4", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog4:SetWidth(15);
LootHistoryOptionsCheckButtonLog4:SetHeight(15);
LootHistoryOptionsCheckButtonLog4:SetPoint("RIGHT", LootHistoryOptionsLog4, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog4:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog4:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog4:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog4:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog4:SetScript("OnClick", function() LootHistoryItemRarity[4] = LootHistorytobool(LootHistoryOptionsCheckButtonLog4:GetChecked()); end);
LootHistoryOptionsCheckButtonLog4:Show();

local LootHistoryOptionsLog5 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog5:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog5:SetWidth(175);
LootHistoryOptionsLog5:SetHeight(15);
LootHistoryOptionsLog5:SetJustifyH("LEFT");
LootHistoryOptionsLog5:SetText(L["legendary"]);
LootHistoryOptionsLog5:SetPoint("TOP", LootHistoryOptionsLog4, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog5 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog5", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog5:SetWidth(15);
LootHistoryOptionsCheckButtonLog5:SetHeight(15);
LootHistoryOptionsCheckButtonLog5:SetPoint("RIGHT", LootHistoryOptionsLog5, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog5:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog5:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog5:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog5:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog5:SetScript("OnClick", function() LootHistoryItemRarity[5] = LootHistorytobool(LootHistoryOptionsCheckButtonLog5:GetChecked()); end);
LootHistoryOptionsCheckButtonLog5:Show();

local LootHistoryOptionsLog6 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLog6:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLog6:SetWidth(175);
LootHistoryOptionsLog6:SetHeight(15);
LootHistoryOptionsLog6:SetJustifyH("LEFT");
LootHistoryOptionsLog6:SetText(L["artifact"]);
LootHistoryOptionsLog6:SetPoint("TOP", LootHistoryOptionsLog5, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLog6 = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLog6", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLog6:SetWidth(15);
LootHistoryOptionsCheckButtonLog6:SetHeight(15);
LootHistoryOptionsCheckButtonLog6:SetPoint("RIGHT", LootHistoryOptionsLog6, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLog6:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLog6:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLog6:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLog6:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLog6:SetScript("OnClick", function() LootHistoryItemRarity[6] = LootHistorytobool(LootHistoryOptionsCheckButtonLog6:GetChecked()); end);
LootHistoryOptionsCheckButtonLog6:Show();

local LootHistoryOptionsLogSolo = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLogSolo:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLogSolo:SetWidth(175);
LootHistoryOptionsLogSolo:SetHeight(15);
LootHistoryOptionsLogSolo:SetJustifyH("LEFT");
LootHistoryOptionsLogSolo:SetText(L["solo"]);
LootHistoryOptionsLogSolo:SetPoint("TOP", LootHistoryOptionsLog6, "BOTTOM", 0, -10);

local LootHistoryOptionsCheckButtonLogSolo = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLogSolo", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLogSolo:SetWidth(15);
LootHistoryOptionsCheckButtonLogSolo:SetHeight(15);
LootHistoryOptionsCheckButtonLogSolo:SetPoint("RIGHT", LootHistoryOptionsLogSolo, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLogSolo:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLogSolo:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLogSolo:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLogSolo:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLogSolo:SetScript("OnClick", function() LootHistoryLog["Solo"] = LootHistorytobool(LootHistoryOptionsCheckButtonLogSolo:GetChecked()); end);
LootHistoryOptionsCheckButtonLogSolo:Show();

local LootHistoryOptionsLogParty = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLogParty:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLogParty:SetWidth(175);
LootHistoryOptionsLogParty:SetHeight(15);
LootHistoryOptionsLogParty:SetJustifyH("LEFT");
LootHistoryOptionsLogParty:SetText(L["party"]);
LootHistoryOptionsLogParty:SetPoint("TOP", LootHistoryOptionsLogSolo, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLogParty = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLogParty", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLogParty:SetWidth(15);
LootHistoryOptionsCheckButtonLogParty:SetHeight(15);
LootHistoryOptionsCheckButtonLogParty:SetPoint("RIGHT", LootHistoryOptionsLogParty, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLogParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLogParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLogParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLogParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLogParty:SetScript("OnClick", function() LootHistoryLog["Party"] = LootHistorytobool(LootHistoryOptionsCheckButtonLogParty:GetChecked()); end);
LootHistoryOptionsCheckButtonLogParty:Show();

local LootHistoryOptionsLogRaid = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLogRaid:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLogRaid:SetWidth(175);
LootHistoryOptionsLogRaid:SetHeight(15);
LootHistoryOptionsLogRaid:SetJustifyH("LEFT");
LootHistoryOptionsLogRaid:SetText(L["raid"]);
LootHistoryOptionsLogRaid:SetPoint("TOP", LootHistoryOptionsLogParty, "BOTTOM", 0, 0);

local LootHistoryOptionsCheckButtonLogRaid = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLogRaid", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLogRaid:SetWidth(15);
LootHistoryOptionsCheckButtonLogRaid:SetHeight(15);
LootHistoryOptionsCheckButtonLogRaid:SetPoint("RIGHT", LootHistoryOptionsLogRaid, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLogRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLogRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLogRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLogRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLogRaid:SetScript("OnClick", function() LootHistoryLog["Raid"] = LootHistorytobool(LootHistoryOptionsCheckButtonLogRaid:GetChecked()); end);
LootHistoryOptionsCheckButtonLogRaid:Show();

local LootHistoryOptionsText3 = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsText3:SetTextColor(1.0, 0.8, 0, 0.8);
LootHistoryOptionsText3:SetWidth(150);
LootHistoryOptionsText3:SetJustifyH("LEFT");
LootHistoryOptionsText3:SetText(L["General-Options:"]);
LootHistoryOptionsText3:SetPoint("TOPLEFT", LootHistoryOptionsLogRaid, "BOTTOMLEFT", -25, -10);

local LootHistoryOptionsLockFrames = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLockFrames:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLockFrames:SetWidth(175);
LootHistoryOptionsLockFrames:SetHeight(15);
LootHistoryOptionsLockFrames:SetJustifyH("LEFT");
LootHistoryOptionsLockFrames:SetText(L["lockFrames"]);
LootHistoryOptionsLockFrames:SetPoint("TOPLEFT", LootHistoryOptionsText3, "BOTTOMLEFT", 25, -5);

local LootHistoryOptionsCheckButtonLockFrames = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLockFrames", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLockFrames:SetWidth(15);
LootHistoryOptionsCheckButtonLockFrames:SetHeight(15);
LootHistoryOptionsCheckButtonLockFrames:SetPoint("RIGHT", LootHistoryOptionsLockFrames, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLockFrames:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLockFrames:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLockFrames:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLockFrames:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLockFrames:SetScript("OnClick", function() 
																LootHistory_LockFrames = LootHistorytobool(LootHistoryOptionsCheckButtonLockFrames:GetChecked());
																if LootHistoryOptionsCheckButtonLockFrames:GetChecked() then
																	LootHistoryFrame:RegisterForDrag("");
																elseif not LootHistoryOptionsCheckButtonLockFrames:GetChecked() then
																	LootHistoryFrame:RegisterForDrag("LeftButton");
																end
															 end);
LootHistoryOptionsCheckButtonLockFrames:Show();

local LootHistoryOptionsEnableMinimapButton = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsEnableMinimapButton:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsEnableMinimapButton:SetWidth(175);
LootHistoryOptionsEnableMinimapButton:SetHeight(15);
LootHistoryOptionsEnableMinimapButton:SetJustifyH("LEFT");
LootHistoryOptionsEnableMinimapButton:SetText(L["enableMinimapButton"]);
LootHistoryOptionsEnableMinimapButton:SetPoint("TOPLEFT", LootHistoryOptionsLockFrames, "BOTTOMLEFT", 0, 0);

local LootHistoryOptionsCheckButtonEnableMinimapButton = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonEnableMinimapButton", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonEnableMinimapButton:SetWidth(15);
LootHistoryOptionsCheckButtonEnableMinimapButton:SetHeight(15);
LootHistoryOptionsCheckButtonEnableMinimapButton:SetPoint("RIGHT", LootHistoryOptionsEnableMinimapButton, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonEnableMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonEnableMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonEnableMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonEnableMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonEnableMinimapButton:SetScript("OnClick", function() 
																		LootHistory_EnableMinimapButton = LootHistorytobool(LootHistoryOptionsCheckButtonEnableMinimapButton:GetChecked());
																		if LootHistoryOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			LootHistoryMinimapButton:Show();
																		elseif not LootHistoryOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			LootHistoryMinimapButton:Hide();
																		end
																	  end);
LootHistoryOptionsCheckButtonEnableMinimapButton:Show();

local LootHistoryOptionsLockMinimapButton = LootHistoryOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryOptionsLockMinimapButton:SetTextColor(1, 1, 1, 0.8);
LootHistoryOptionsLockMinimapButton:SetWidth(175);
LootHistoryOptionsLockMinimapButton:SetHeight(15);
LootHistoryOptionsLockMinimapButton:SetJustifyH("LEFT");
LootHistoryOptionsLockMinimapButton:SetText(L["lockMinimapButton"]);
LootHistoryOptionsLockMinimapButton:SetPoint("TOPLEFT", LootHistoryOptionsEnableMinimapButton, "BOTTOMLEFT", 0, 0);

local LootHistoryOptionsCheckButtonLockMinimapButton = CreateFrame("CHECKBUTTON", "LootHistoryOptionsCheckButtonLockMinimapButton", LootHistoryOptionsFrame);
LootHistoryOptionsCheckButtonLockMinimapButton:SetWidth(15);
LootHistoryOptionsCheckButtonLockMinimapButton:SetHeight(15);
LootHistoryOptionsCheckButtonLockMinimapButton:SetPoint("RIGHT", LootHistoryOptionsLockMinimapButton, "LEFT", -5, 0);
LootHistoryOptionsCheckButtonLockMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryOptionsCheckButtonLockMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryOptionsCheckButtonLockMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryOptionsCheckButtonLockMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryOptionsCheckButtonLockMinimapButton:SetScript("OnClick", function()
																		LootHistory_LockMinimapButton = LootHistorytobool(LootHistoryOptionsCheckButtonLockMinimapButton:GetChecked());
																		if LootHistoryOptionsCheckButtonLockMinimapButton:GetChecked() then
																			LootHistoryMinimapButton:RegisterForDrag(""); 
																		elseif not LootHistoryOptionsCheckButtonLockMinimapButton:GetChecked() then																			
																			LootHistoryMinimapButton:RegisterForDrag("LeftButton");
																		end
																	end);
LootHistoryOptionsCheckButtonLockMinimapButton:Show();

local LootHistoryReportFrame = CreateFrame("FRAME", "LootHistoryReportFrame", UIParent);
LootHistoryReportFrame:SetFrameStrata("TOOLTIP"); 
LootHistoryReportFrame:SetWidth(200);
LootHistoryReportFrame:SetHeight(210);
LootHistoryReportFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryReportFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryReportFrame:SetPoint("CENTER");
LootHistoryReportFrame:EnableMouse(true);
LootHistoryReportFrame:RegisterForDrag("LeftButton");
LootHistoryReportFrame:SetMovable(true);
LootHistoryReportFrame:SetUserPlaced(true);
LootHistoryReportFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LootHistoryReportFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LootHistoryReportFrame:Hide();
tinsert(UISpecialFrames, LootHistoryReportFrame:GetName());

local LootHistoryReportFrameTop = CreateFrame("FRAME", nil, LootHistoryReportFrame);
LootHistoryReportFrameTop:SetWidth(120);
LootHistoryReportFrameTop:SetHeight(25);
LootHistoryReportFrameTop:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryReportFrameTop:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryReportFrameTop:SetPoint("TOP", 0, 10);
LootHistoryReportFrameTop:Show();

local LootHistoryReportFrameText = LootHistoryReportFrameTop:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameText:SetTextColor(1, 0, 0, 1.0);
LootHistoryReportFrameText:SetText(L["Report"]);
LootHistoryReportFrameText:SetPoint("CENTER");

local LootHistoryReportFrameClose = CreateFrame("BUTTON", nil, LootHistoryReportFrame, "UIPanelButtonTemplate");
LootHistoryReportFrameClose:SetWidth(15);
LootHistoryReportFrameClose:SetHeight(15);
LootHistoryReportFrameClose:SetText("X");
LootHistoryReportFrameClose:SetPoint("TOPRIGHT", -5, -5);
LootHistoryReportFrameClose:SetScript("OnClick", function()
											LootHistoryReportFrame:Hide();											
										   end);
LootHistoryReportFrameClose:SetAlpha(1);
LootHistoryReportFrameClose:Show();

local LootHistoryReportFrameText = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
LootHistoryReportFrameText:SetWidth(175);
LootHistoryReportFrameText:SetJustifyH("LEFT");
LootHistoryReportFrameText:SetText(L["Report:"]);
LootHistoryReportFrameText:SetPoint("TOPLEFT", 5, -30);

local LootHistoryReportFrameChatFrame = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameChatFrame:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameChatFrame:SetWidth(175);
LootHistoryReportFrameChatFrame:SetHeight(15);
LootHistoryReportFrameChatFrame:SetJustifyH("LEFT");
LootHistoryReportFrameChatFrame:SetText(L["ChatFrame1"]);
LootHistoryReportFrameChatFrame:SetPoint("TOP", LootHistoryReportFrameText, "BOTTOM", 25, -5);

local LootHistoryReportFrameCheckButtonChatFrame = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonChatFrame", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonChatFrame:SetWidth(15);
LootHistoryReportFrameCheckButtonChatFrame:SetHeight(15);
LootHistoryReportFrameCheckButtonChatFrame:SetPoint("RIGHT", LootHistoryReportFrameChatFrame, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonChatFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonChatFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonChatFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonChatFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonChatFrame:SetScript("OnClick", function() LootHistoryReportTo["ChatFrame1"] = LootHistorytobool(LootHistoryReportFrameCheckButtonChatFrame:GetChecked()); end);
LootHistoryReportFrameCheckButtonChatFrame:Show();

local LootHistoryReportFrameSay = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameSay:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameSay:SetWidth(175);
LootHistoryReportFrameSay:SetHeight(15);
LootHistoryReportFrameSay:SetJustifyH("LEFT");
LootHistoryReportFrameSay:SetText(L["/say"]);
LootHistoryReportFrameSay:SetPoint("TOP", LootHistoryReportFrameChatFrame, "BOTTOM", 0, 0);

local LootHistoryReportFrameCheckButtonSay = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonSay", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonSay:SetWidth(15);
LootHistoryReportFrameCheckButtonSay:SetHeight(15);
LootHistoryReportFrameCheckButtonSay:SetPoint("RIGHT", LootHistoryReportFrameSay, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonSay:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonSay:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonSay:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonSay:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonSay:SetScript("OnClick", function() LootHistoryReportTo["Say"] = LootHistorytobool(LootHistoryReportFrameCheckButtonSay:GetChecked()); end);
LootHistoryReportFrameCheckButtonSay:Show();

local LootHistoryReportFrameYell = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameYell:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameYell:SetWidth(175);
LootHistoryReportFrameYell:SetHeight(15);
LootHistoryReportFrameYell:SetJustifyH("LEFT");
LootHistoryReportFrameYell:SetText(L["/yell"]);
LootHistoryReportFrameYell:SetPoint("TOP", LootHistoryReportFrameSay, "BOTTOM", 0, 0);

local LootHistoryReportFrameCheckButtonYell = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonYell", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonYell:SetWidth(15);
LootHistoryReportFrameCheckButtonYell:SetHeight(15);
LootHistoryReportFrameCheckButtonYell:SetPoint("RIGHT", LootHistoryReportFrameYell, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonYell:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonYell:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonYell:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonYell:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonYell:SetScript("OnClick", function() LootHistoryReportTo["Yell"] = LootHistorytobool(LootHistoryReportFrameCheckButtonYell:GetChecked()); end);
LootHistoryReportFrameCheckButtonYell:Show();

local LootHistoryReportFrameParty = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameParty:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameParty:SetWidth(175);
LootHistoryReportFrameParty:SetHeight(15);
LootHistoryReportFrameParty:SetJustifyH("LEFT");
LootHistoryReportFrameParty:SetText(L["/party"]);
LootHistoryReportFrameParty:SetPoint("TOP", LootHistoryReportFrameYell, "BOTTOM", 0, 0);

local LootHistoryReportFrameCheckButtonParty = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonParty", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonParty:SetWidth(15);
LootHistoryReportFrameCheckButtonParty:SetHeight(15);
LootHistoryReportFrameCheckButtonParty:SetPoint("RIGHT", LootHistoryReportFrameParty, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonParty:SetScript("OnClick", function() LootHistoryReportTo["Party"] = LootHistorytobool(LootHistoryReportFrameCheckButtonParty:GetChecked()); end);
LootHistoryReportFrameCheckButtonParty:Show();

local LootHistoryReportFrameRaid = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameRaid:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameRaid:SetWidth(175);
LootHistoryReportFrameRaid:SetHeight(15);
LootHistoryReportFrameRaid:SetJustifyH("LEFT");
LootHistoryReportFrameRaid:SetText(L["/raid"]);
LootHistoryReportFrameRaid:SetPoint("TOP", LootHistoryReportFrameParty, "BOTTOM", 0, 0);

local LootHistoryReportFrameCheckButtonRaid = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonRaid", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonRaid:SetWidth(15);
LootHistoryReportFrameCheckButtonRaid:SetHeight(15);
LootHistoryReportFrameCheckButtonRaid:SetPoint("RIGHT", LootHistoryReportFrameRaid, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");	
LootHistoryReportFrameCheckButtonRaid:SetScript("OnClick", function() LootHistoryReportTo["Raid"] = LootHistorytobool(LootHistoryReportFrameCheckButtonRaid:GetChecked()); end);
LootHistoryReportFrameCheckButtonRaid:Show();

local LootHistoryReportFrameGuild = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameGuild:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameGuild:SetWidth(175);
LootHistoryReportFrameGuild:SetHeight(15);
LootHistoryReportFrameGuild:SetJustifyH("LEFT");
LootHistoryReportFrameGuild:SetText(L["/guild"]);
LootHistoryReportFrameGuild:SetPoint("TOP", LootHistoryReportFrameRaid, "BOTTOM", 0, 0);

local LootHistoryReportFrameCheckButtonGuild = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonGuild", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonGuild:SetWidth(15);
LootHistoryReportFrameCheckButtonGuild:SetHeight(15);
LootHistoryReportFrameCheckButtonGuild:SetPoint("RIGHT", LootHistoryReportFrameGuild, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonGuild:SetScript("OnClick", function() LootHistoryReportTo["Guild"] = LootHistorytobool(LootHistoryReportFrameCheckButtonGuild:GetChecked()); end);
LootHistoryReportFrameCheckButtonGuild:Show();

local LootHistoryReportFrameWhisper = LootHistoryReportFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryReportFrameWhisper:SetTextColor(1, 1, 1, 0.8);
LootHistoryReportFrameWhisper:SetWidth(100);
LootHistoryReportFrameWhisper:SetHeight(15);
LootHistoryReportFrameWhisper:SetJustifyH("LEFT");
LootHistoryReportFrameWhisper:SetText(L["/whisper:"]);
LootHistoryReportFrameWhisper:SetPoint("TOPLEFT", LootHistoryReportFrameGuild, "BOTTOMLEFT");

local LootHistoryReportFrameCheckButtonWhisper = CreateFrame("CHECKBUTTON", "LootHistoryReportFrameCheckButtonWhisper", LootHistoryReportFrame);
LootHistoryReportFrameCheckButtonWhisper:SetWidth(15);
LootHistoryReportFrameCheckButtonWhisper:SetHeight(15);
LootHistoryReportFrameCheckButtonWhisper:SetPoint("RIGHT", LootHistoryReportFrameWhisper, "LEFT", -5, 0);
LootHistoryReportFrameCheckButtonWhisper:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
LootHistoryReportFrameCheckButtonWhisper:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
LootHistoryReportFrameCheckButtonWhisper:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
LootHistoryReportFrameCheckButtonWhisper:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
LootHistoryReportFrameCheckButtonWhisper:SetScript("OnClick", function() LootHistoryReportTo["Whisper"] = LootHistorytobool(LootHistoryReportFrameCheckButtonWhisper:GetChecked()); end);
LootHistoryReportFrameCheckButtonWhisper:Show();

local LootHistoryReportFrameWhisperBox = CreateFrame("EDITBOX", "LootHistoryReportFrameWhisperBox", LootHistoryReportFrame, "InputBoxTemplate")
LootHistoryReportFrameWhisperBox:SetWidth(90);
LootHistoryReportFrameWhisperBox:SetHeight(15);
LootHistoryReportFrameWhisperBox:SetPoint("LEFT", LootHistoryReportFrameWhisper, "RIGHT", -40, -2);
LootHistoryReportFrameWhisperBox:SetMaxLetters(12);
LootHistoryReportFrameWhisperBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("TARGET");
														if not (n == nil) then
														LootHistoryReportFrameWhisperBox:SetText(n);
													end
												end);

LootHistoryReportFrameWhisperBox:SetScript("OnEnterPressed", function() LootHistoryReportFrameWhisperBox:ClearFocus(); end);
LootHistoryReportFrameWhisperBox:SetScript("OnTextChanged", function()
	local h = LootHistoryReportFrameWhisperBox:GetText()
	if #h == 1 then
		LootHistoryReportFrameWhisperBox:SetText(strupper(h));
	elseif #h > 1 then
		local a = strsub(h, 1, 1);
		local b = strsub(h, 2);		
		LootHistoryReportFrameWhisperBox:SetText(strupper(a)..strlower(b));
	end
	LootHistoryWhisperBox = LootHistoryReportFrameWhisperBox:GetText();
end);
LootHistoryReportFrameWhisperBox:SetAutoFocus(false);
LootHistoryReportFrameWhisperBox:Show();

local LootHistoryReportFrameReportButton = CreateFrame("BUTTON", "LootHistoryReportFrameReportButton", LootHistoryReportFrame, "UIPanelButtonTemplate");
LootHistoryReportFrameReportButton:SetWidth(180);
LootHistoryReportFrameReportButton:SetHeight(30);
LootHistoryReportFrameReportButton:SetText(L["report"]);
LootHistoryReportFrameReportButton:SetPoint("BOTTOM", LootHistoryReportFrame, "BOTTOM", 0, 10);
LootHistoryReportFrameReportButton:SetScript("OnClick", function()													
													LootHistoryReportData();													
												end);
LootHistoryReportFrameReportButton:SetAlpha(1);
LootHistoryReportFrameReportButton:Show();

local LootHistoryEditFrame = CreateFrame("FRAME", "LootHistoryEditFrame", UIParent);
LootHistoryEditFrame:SetFrameStrata("TOOLTIP"); 
LootHistoryEditFrame:SetWidth(310);
LootHistoryEditFrame:SetHeight(35);
LootHistoryEditFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryEditFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryEditFrame:SetPoint("CENTER");
LootHistoryEditFrame:EnableMouse(true);
LootHistoryEditFrame:RegisterForDrag("LeftButton");
LootHistoryEditFrame:SetMovable(true);
LootHistoryEditFrame:SetUserPlaced(true);
LootHistoryEditFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LootHistoryEditFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LootHistoryEditFrame:Hide();
tinsert(UISpecialFrames, LootHistoryEditFrame:GetName());

local LootHistoryEditFrameBox = CreateFrame("EDITBOX", "LootHistoryEditFrameBox", LootHistoryEditFrame, "InputBoxTemplate")
LootHistoryEditFrameBox:SetWidth(90);
LootHistoryEditFrameBox:SetHeight(15);
LootHistoryEditFrameBox:SetPoint("LEFT", 15, 0);
LootHistoryEditFrameBox:SetMaxLetters(12);
LootHistoryEditFrameBox:SetScript("OnEnterPressed", function() LootHistoryEditFrameBox:ClearFocus(); end);
LootHistoryEditFrameBox:SetScript("OnTextChanged", function()
	local h = LootHistoryEditFrameBox:GetText()
	if #h == 1 then
		LootHistoryEditFrameBox:SetText(strupper(h));
	elseif #h > 1 then
		local a = strsub(h, 1, 1);
		local b = strsub(h, 2);		
		LootHistoryEditFrameBox:SetText(strupper(a)..strlower(b));
	end
end);
LootHistoryEditFrameBox:SetAutoFocus(false);
LootHistoryEditFrameBox:Show();

local LootHistoryEditFrameLoot = LootHistoryEditFrame:CreateFontString("LootHistoryEditFrameLoot", "Artwork", "ChatFontNormal");
LootHistoryEditFrameLoot:SetTextColor(1, 1, 1, 0.8);
LootHistoryEditFrameLoot:SetWidth(150);
LootHistoryEditFrameLoot:SetHeight(15);
LootHistoryEditFrameLoot:SetJustifyH("LEFT");
LootHistoryEditFrameLoot:SetPoint("LEFT", LootHistoryEditFrameBox, "RIGHT", 5, 0);
LootHistoryEditFrameLoot:Show();

local LootHistoryEditFrameBoxButton = CreateFrame("BUTTON", "LootHistoryEditFrameBoxButton", LootHistoryEditFrame, "UIPanelButtonTemplate");
LootHistoryEditFrameBoxButton:SetWidth(30);
LootHistoryEditFrameBoxButton:SetHeight(25);
LootHistoryEditFrameBoxButton:SetText("OK");
LootHistoryEditFrameBoxButton:SetPoint("LEFT", LootHistoryEditFrameLoot, "RIGHT", 5, 0);
LootHistoryEditFrameBoxButton:SetScript("OnClick", function()
													local itemLink = LootHistory[editName][editItem];
													local userName = LootHistoryEditFrameBox:GetText();													
													if (not (userName == editName)) then														
														if editMode == 1 then
															tremove(LootHistory[editName], editItem);
															LootHistory_tinsert(userName, itemLink);
														elseif editMode == 2 then
															local b, _ = strfind(itemLink, "%]");
															if ((b + 6) <= #itemLink) then
																local itemCount = tonumber(string.sub(itemLink, b + 6, #itemLink));
																local itemLink2 = string.sub(itemLink, 1, b + 4);
																if itemCount > 2 then
																	itemLink = itemLink2;
																	itemLink2 = itemLink2.."x"..itemCount - 1;
																else
																	itemLink = itemLink2;
																end
																tremove(LootHistory[editName], editItem);																
																LootHistory_tinsert(editName, itemLink2);
																LootHistory_tinsert(userName, itemLink);
															else
																tremove(LootHistory[editName], editItem);															
																LootHistory_tinsert(userName, itemLink);
															end
														end
														LootHistoryRefreshSChildFrame();
													end
													LootHistoryEditFrame:Hide();													
												end);
LootHistoryEditFrameBoxButton:SetAlpha(1);
LootHistoryEditFrameBoxButton:Show();

local LootHistoryItemTooltip = CreateFrame("GameTooltip", "LootHistoryItemTooltip", nil, "GameTooltipTemplate" );
LootHistoryItemTooltip:SetFrameStrata("TOOLTIP");
LootHistoryItemTooltip:SetScale(0.7);
LootHistoryItemTooltip:EnableMouse(true);
LootHistoryItemTooltip:RegisterForDrag("LeftButton");
LootHistoryItemTooltip:SetMovable(true);
LootHistoryItemTooltip:SetUserPlaced(true);
LootHistoryItemTooltip:SetScript("OnDragStart", function() LootHistoryItemTooltip:StartMoving() end);
LootHistoryItemTooltip:SetScript("OnDragStop", function()
													LootHistoryItemTooltip:StopMovingOrSizing();
												 end);
LootHistoryItemTooltip:Hide();
tinsert(UISpecialFrames, LootHistoryItemTooltip:GetName());

local LootHistoryTooltipClose = CreateFrame("BUTTON", nil, LootHistoryItemTooltip, "UIPanelButtonTemplate");
LootHistoryTooltipClose:SetWidth(15);
LootHistoryTooltipClose:SetHeight(15);
LootHistoryTooltipClose:SetText("X");
LootHistoryTooltipClose:SetPoint("TOPRIGHT", -5, -3);
LootHistoryTooltipClose:SetScript("OnClick", function()
											LootHistoryItemTooltip:Hide();											
										   end);
LootHistoryTooltipClose:SetAlpha(1);
LootHistoryTooltipClose:Show();

local LootHistoryHelpFrame = CreateFrame("FRAME", "LootHistoryHelpFrame", UIParent);
LootHistoryHelpFrame:SetFrameStrata("TOOLTIP"); 
LootHistoryHelpFrame:SetWidth(LootHistoryFrame:GetWidth());
LootHistoryHelpFrame:SetHeight(230);
if (GetLocale() == "deDE") then
	LootHistoryHelpFrame:SetHeight(245);
end
LootHistoryHelpFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
LootHistoryHelpFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
LootHistoryHelpFrame:SetPoint("BOTTOM", LootHistoryFrame, "TOP", 0, 0);
LootHistoryHelpFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
LootHistoryHelpFrame:SetScript("OnDragStop", function(this) this:StopMovingOrSizing(); end);
LootHistoryHelpFrame:Hide();
tinsert(UISpecialFrames, LootHistoryHelpFrame:GetName());

local LootHistoryHelpFrameText = LootHistoryHelpFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
LootHistoryHelpFrameText:SetTextColor(1.0, 0.8, 0, 0.8);
LootHistoryHelpFrameText:SetWidth(230);
LootHistoryHelpFrameText:SetJustifyH("LEFT");
LootHistoryHelpFrameText:SetText(L["Help"]);
LootHistoryHelpFrameText:SetPoint("TOPLEFT", 5, -10);